function love.load()
    math.randomseed(os.time())
    math.random(); math.random(); math.random()
    angle = (3 * math.pi / 2) - (math.pi / 8)
    x = 400
    y = 300
    ball1x,ball1y = 30, 300
    speedint = 200
    speed1x,speed1y = speedint, math.random(-speedint,speedint)
    if speed1y < 50 and speed1y > 0 then
        speed1y = speed1y + 50
    end
    if speed1y > -50 and speed1y < 0 then
        speed1y = speed1y - 50
    end
    isgoing = false
    ismoving = false
    dead = false
    time = 0
    ball1angle = 0
    redangle,redangle2 = 0,0
    greenangle,greenangle2 = 0,0
    speedangle = 0
    isfx = true
    ismusic = true
    music = love.audio.newSource("sounds/techno80.mp3")
    music:setLooping(true)
    music:setVolume(60)
    music:play()
    fx = love.audio.newSource("sounds/ball.mp3")
    fx:setLooping(false)
    fx:setVolume(80)
end

function love.update(dt)
    if not dead and isgoing then
        time = time + dt
        if math.ceil(time) % 10 == 0 then
            if speed1x > 0 then
                speed1x = speed1x + (50 * dt)
            else
                speed1x = speed1x - (50 * dt)
            end
        end
    end
    ismoving = false
    if ball1x < 10 then
        ball1x = 10
        speed1x = -speed1x
        if isfx then
            fx:play()
        end
    elseif ball1x > 790 then
        ball1x = 790
        speed1x = -speed1x
        if isfx then
            fx:play()
        end
    end
    if ball1y < 10 then
        ball1y = 10
        speed1y = -speed1y
        if isfx then
            fx:play()
        end
    elseif ball1y > 590 then
        ball1y = 590
        speed1y = -speed1y
        if isfx then
            fx:play()
        end
    end
    speedint = speedint + (1 * dt)
        ball1angle = math.deg(math.atan2((ball1y - y) , (ball1x - x)))
        if ball1angle < 0 then
            ball1angle = ball1angle + 360
        end
        redangle = math.deg(angle)
        redangle2 = math.deg(angle + math.pi / 4)
        if redangle > 315 and redangle < 360 and ball1angle < 45 then
            ball1angle = ball1angle + 360
        end
        greenangle = redangle - 180
        greenangle2 = redangle2 - 180
        if greenangle < 0 then
            greenangle = greenangle + 360
            greenangle2 = greenangle2 + 360
        end
        if greenangle > 315 and greenangle < 360 and ball1angle < 45 then
            ball1angle = ball1angle + 360
        end
    if not dead and isgoing then
        ball1x = ball1x + (speed1x * dt)
        ball1y = ball1y + (speed1y * dt)
        if (ball1y - y)^2 + (ball1x - x)^2 < 110^2 then
            if (ball1angle > redangle and ball1angle < redangle2) or (ball1angle > greenangle and ball1angle < greenangle2) then
                if isfx then
                    fx:play()
                end
                if (speed1x > 0 and ball1angle >= 120 and ball1angle <= 240) then
                    speed1x = -speed1x
                elseif (speed1x < 0 and ball1angle <= 405 and ball1angle >= 300) then
                    speed1x = -speed1x
                elseif (speed1x < 0 and ball1angle >= 45 and ball1angle <= 60) then
                    speed1x = -speed1x
                elseif (speed1x < 0 and ball1angle <= 45 and ball1angle > 0) then
                    speed1x = -speed1x
                end
                if (speed1y > 0 and ball1angle <= 330 and ball1angle >= 210) then
                    speed1y = -speed1y
                elseif (speed1y < 0 and ball1angle >= 45 and ball1angle <= 150) then
                    speed1y = -speed1y
                elseif (speed1y < 0 and ball1angle <= 405 and ball1angle >= 390) then
                    speed1y = -speed1y
                elseif (speed1y < 0 and ball1angle <= 45 and ball1angle > 0) then
                    speed1y = -speed1y
                end
            end
        end
        if (ball1y - y)^2 + (ball1x - x)^2 < 90^2 then
            dead = true
            isgoing = false
        end
    end
    if love.keyboard.isDown("left") then
        angle = (angle - (3*math.pi/4) * dt)
        if (angle <= 0) then
            angle = 2*math.pi
        end
        ismoving = true
    end
    if love.keyboard.isDown("right") then
        angle = (angle + (3*math.pi/4) * dt)
        if (angle >= 2 * math.pi) then
            angle = 0
        end
        ismoving = true
    end
    if love.keyboard.isDown("space") and not isgoing then
        isgoing = true
        ismoving = false
    end
    if love.keyboard.isDown("space") and dead then
        dead = false
        isgoing = true
        ismoving = false
        angle = (3 * math.pi / 2) - (math.pi / 8)
        x = 400
        y = 300
        ball1x,ball1y = 30, 300
        speedint = 200
        speed1x,speed1y = speedint, math.random(-speedint,speedint)
        if speed1y < 50 and speed1y > 0 then
            speed1y = speed1y + 50
        end
        if speed1y > -50 and speed1y < 0 then
            speed1y = speed1y - 50
        end
        time = 0
    end
    if love.keyboard.isDown("f5") then
        love.event.quit("restart")
    end
end

function love.keyreleased(key)
    if key == "escape" and not isgoing then
        love.event.quit()
    end
    if key == "escape" and isgoing then
        dead = false
        isgoing = false
        angle = (3 * math.pi / 2) - (math.pi / 8)
        x = 400
        y = 300
        ball1x,ball1y = 30, 300
        speedint = 200
        speed1x,speed1y = speedint, math.random(-speedint,speedint)
        if speed1y < 50 and speed1y > 0 then
            speed1y = speed1y + 50
        end
        if speed1y > -50 and speed1y < 0 then
            speed1y = speed1y - 50
        end
        time = 0
    end
    if key == "f" then
        if isfx then
            isfx = false
        else
            isfx = true
        end
    end
    if key == "m" then
        if ismusic then
            ismusic = false
            music:stop()
        else
            ismusic = true
            music:play()
        end
    end
end

function love.draw()
    love.graphics.setColor(255,0,0)
    love.graphics.arc("fill", "pie", x, y, 100, angle, (math.pi / 4) + angle)
    love.graphics.setColor(0,255,0)
    love.graphics.arc("fill", "pie", x, y, 100, angle - math.pi, (math.pi / 4) + angle - math.pi )
    love.graphics.setColor(0,0,255)
    love.graphics.circle("fill", x, y, 92)
    love.graphics.setColor(0,0,0)
    love.graphics.setLineWidth(8)
    love.graphics.circle("line", x, y, 92)
    love.graphics.setColor(255,0,255)
    love.graphics.circle("fill", ball1x, ball1y, 10)
    if not dead then
        if ismoving then
            love.graphics.setColor(255,255,0)
        else
            love.graphics.setColor(100,100,100)
        end
    else
        love.graphics.setColor(255,0,0)
    end
    love.graphics.circle("fill", x, y, 10)
    love.graphics.setColor(255,255,255)
    if not isgoing and not dead then
        love.graphics.setNewFont(24)
        love.graphics.print("Press Space to start.", 30, 30)
    end
    if not dead and isgoing then
        love.graphics.setNewFont(48)
        love.graphics.print(math.floor(time), 30, 30)
    end
    if dead and not isgoing then
        love.graphics.setNewFont(24)
        love.graphics.print("You survived "..math.floor(time).." seconds.", 30, 30)
        if time > 70 and time < 80 then
            love.graphics.print("Not bad!", 30, 90)
        elseif time > 80 and time < 85 then
            love.graphics.print("Awesome!", 30, 90)
        elseif time > 90 then
            love.graphics.print("You played just wonderfully!", 30 ,90)
        end
        love.graphics.print("Press Space to try again.", 30, 120)
    end
    love.graphics.setNewFont(16)
    love.graphics.setColor(255,255,255)
    if isfx then
        love.graphics.print("(F)x: on ", 600, 30)
    else
        love.graphics.print("(F)x: off", 600, 30)
    end
    if ismusic then
        love.graphics.print("(M)usic: on ", 680, 30)
    else
        love.graphics.print("(M)usic: off", 680, 30)
    end
end
